package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.TSSDPolicy;
import com.sa.ibiz.demo.demo.service.TSSDPolicyService;
import com.sa.ibiz.demo.demo.service.dto.TSSDPolicySearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/tssdpolicy")
public class TSSDPolicyResource
{
	@Autowired
	private TSSDPolicyService service;


	@PostMapping(value = "/remove")
	public ResponseEntity<TSSDPolicy> remove(@Validated @RequestBody TSSDPolicy data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略[remove]操作发生错误","TSSDPolicy",data.getTssdpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<TSSDPolicy> update(@Validated @RequestBody TSSDPolicy data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略[update]操作发生错误","TSSDPolicy",data.getTssdpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<TSSDPolicy> getDraft(@Validated @RequestBody TSSDPolicy data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略[getDraft]操作发生错误","TSSDPolicy","");
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<TSSDPolicy> get(@Validated @PathVariable String id){
		TSSDPolicy data=new TSSDPolicy();
		data.setTssdpolicyid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("任务时刻策略[get]操作发生错误","TSSDPolicy",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<TSSDPolicy> create(@Validated @RequestBody TSSDPolicy data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略[create]操作发生错误","TSSDPolicy",data.getTssdpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<TSSDPolicy> checkKey(@Validated @RequestBody TSSDPolicy data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("任务时刻策略[checkKey]操作发生错误","TSSDPolicy",data.getTssdpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<TSSDPolicy>> searchDefaultPage(@Validated @RequestBody TSSDPolicySearchFilter filter){
		Page<TSSDPolicy> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<TSSDPolicy>> listDefault(@Validated @RequestBody TSSDPolicySearchFilter filter){
		List<TSSDPolicy> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
